#!/usr/bin/perl -T

use strict;
use warnings;

#*******************************************************************************
# Mentat::Processor::Engine::Enricher module/class tests
#
# Author:   Jan Mach, jan.mach@cesnet.cz
# Version:  0.1
# Purpose:
#
#*******************************************************************************

use Data::Dumper;
#use Smart::Comments;

use Test::More tests => 4;

# First test if the module correctly compiles
BEGIN {
        use vars qw($TESTED_CLASS);
        $TESTED_CLASS = 'Mentat::Processor::Engine::Enricher';

        use_ok('Tester');
        use_ok('Mentat::Processor::Message::Factory');
        use_ok('Mentat::Message::Factory');
        use_ok($TESTED_CLASS);
    }

# Debug output explicit ON switch
#Tester::DEBUG_ON();

# Debug output explicit OFF switch
#Tester::DEBUG_OFF();

# User should know, which version is beeing tested (just for sure)
#diag("$TESTED_CLASS version: " . $Mentat::Processor::Engine::Enricher::VERSION) if Tester::D();
#diag("Mentat::Processor::Message::Factory version: " . $Mentat::Processor::Message::Factory::VERSION) if Tester::D();
#diag("Mentat::Message::Factory version: " . $Mentat::Message::Factory::VERSION) if Tester::D();

## Now attempt to create a class instance and check it
#my $instance = $TESTED_CLASS->new();
#isa_ok($instance, $TESTED_CLASS);

## View the created instance
#diag("Instance dump 01: " . Dumper($instance)) if Tester::D();

## Create test ALERT request
#my $alert = Mentat::Message::Factory->from_file('./data/alert01.idea');
#my $request = Mentat::Processor::Message::Factory->forge('alert', 'idea', $alert->to_string());
#$request->attribute('alert_obj', $alert);

#diag("Result 01: " . Dumper($instance->process('endpoint_in', $request))) if Tester::D();
