#!/usr/bin/perl -T

use strict;
use warnings;

#*******************************************************************************
# Mentat::Processor::Engine::Filter module/class tests
#
# Author:   Jan Mach, jan.mach@cesnet.cz
# Version:  0.1
# Purpose:
#
#*******************************************************************************

use Data::Dumper;
#use Smart::Comments;

use Test::More tests => 4;

# First test if the module correctly compiles
BEGIN {
        use vars qw($TESTED_CLASS);
        $TESTED_CLASS = 'Mentat::Processor::Engine::Filter';

        use_ok('Tester');
        use_ok('Mentat::Processor::Message::Factory');
        use_ok('Mentat::Message::Factory');
        use_ok($TESTED_CLASS);
    }

# Debug output explicit ON switch
#Tester::DEBUG_ON();

# Debug output explicit OFF switch
#Tester::DEBUG_OFF();

# User should know, which version is beeing tested (just for sure)
### $Mentat::Processor::Message::Factory::VERSION
### $Mentat::Message::Factory::VERSION
### $Mentat::Processor::Engine::Filter::VERSION

#use Log::Loger;
#Log::Loger->writer('writer1','std');
#Log::Loger->channel(undef,'writer1','ACCEPT');

# Create test ALERT request
#my $alert = Mentat::Message::Factory->from_file('./data/alert01.idea');
#my $request = Mentat::Processor::Request->new_request('alert', 'idea', $alert->to_string());
#$request->attribute('alert_obj', $alert);

## Configure the test filter configurations
#my $instance;
#my @TESTS = (
        #['./conf/filter-rules.conf', 1],
        #[{
          #'deny' => [
                      #'? Heartbeat',
                      #'Alert/@messageid == "1234" and Alert/Target/@ident eq "d1c2b3a4"'
                    #],
          #'allow' => [
                       #'? Alert',
                       #'Alert/@messageid == "1234" and Alert/Target/@ident eq "d1c2b3a4"'
                     #],
        #}, 1],
        #[{
          #'order' => 'deny',
          #'deny' => [
                      #'? Heartbeat',
                      #'Alert/@messageid == "1234" and Alert/Target/@ident eq "d1c2b3a4"'
                    #],
          #'allow' => [
                       #'? Alert',
                       #'Alert/@messageid == "1234" and Alert/Target/@ident eq "d1c2b3a4"'
                     #],
        #}, 0],
        #[{
          #'logop_allow' => 'and',
          #'order' => 'allow',
          #'deny' => [
                      #'? Heartbeat',
                      #'Alert/@messageid == "1234" and Alert/Target/@ident eq "d1c2b3a4"'
                    #],
          #'allow' => [
                       #'? Alert',
                       #'Alert/@messageid == "1234" and Alert/Target/@ident eq "d1c2b3a4"'
                     #],
          #'default_action' => 'deny'
        #}, 1],
    #);

## Run all above configured tests
#my $counter = 0;
#foreach my $test (@TESTS)
#{
    ## Now attempt to create a class instance and check it
    #$instance = $TESTED_CLASS->new($engine, './conf/filter-grammar.conf', $test->[0]);
    #isa_ok($instance, $TESTED_CLASS);

    ## View the created instance
    #diag("Instance dump 01: " . Dumper($instance)) if Tester::D();

    #is($instance->process('endpoint_in', $request), $test->[1], "Filter test " . ++$counter);
#}
